#ifndef __LIBW83627_H_
#define	__LIBW83627_H_

#include <sys/ioctl.h>

#ifdef __cplusplus
    extern "C" {
#endif

typedef unsigned char   u8;
typedef int   i32;
typedef char  i8;
typedef short   i16;
typedef unsigned short u16;
typedef unsigned int u32;

int libw83627_init(void);
void lib_close(void);

/*GPIO*/
int get_gpi_status(int pin);
int get_gpo_status(int pin);
void set_gpo(int pin, int value);

/*Watch Dog*/
//timevalue 1~255, timetype 0:sec 1:mins
void wdt_start(int _timevalue);
void wdt_stop(void);
int get_wdt_count(void);

/*LAN BYPASS*/
int get_bypass_firmware_ver(char *ver);
int set_bypass_wdt(int pair, int time); //0-255, 0:stop
int set_bypass_wdt_action(int pair, int action);
int get_bypass_wdt_action(int pair);
int set_bypass_poweron_action(int pair, int action);
int get_bypass_poweron_action(int pair);
int set_bypass_poweroff_action(int pair, int action);
int get_bypass_poweroff_action(int pair);
int set_bypass_current_action(int pair, int action);
int get_bypass_current_action(int pair);

/*LCM*/

i32 displayLcm(int mode);
i32 setPositionLcm(i32 row, i32 column);
i32 getPositionLcm(i32 *row, i32 *column);
i32 cursorLcm(int mode);
i32 cursorActionLcm(i32 type);
i32 clrscrLcm(void);
i32 showLcm(i32 length, u8* info);
i32 getKeyLcm(void);
int getLcmMode(void);
void getLCMPICVER(char *ver);
int setBacklight(int mode);
void graphicwritelcm(int x, int y, unsigned char data);

//psu for i2c
int i2c_init(void);
unsigned char i2c_read_byte(unsigned char cmd);
int get_i2c_psu_temperature(void);
float get_i2c_psu_vout_3V3(void);
float get_i2c_psu_vout_5V(void);
float get_i2c_psu_vout_12V(void);
int get_i2c_psu_fan_status(int fan);
int get_i2c_psu_status(int psu);
void i2c_close(void);

//psu for pmbus
unsigned char pmbus_read_byte(unsigned char cmd);
void pmbus_write_byte(unsigned char cmd, unsigned char data);
short pmbus_read_word(unsigned char cmd);
void pmbus_read_ascii(unsigned char cmd, char *data);
float pmbus_read_vout_12V(void);
float pmbus_read_vout_3V3(void);
float pmbus_read_vout_5V(void);
int get_pmbus_psu_status(int psu);

//chassis
int get_chassis_open_status(void);
void set_chassis_open(int value);

#define HOME 0x01
#define MOVERIGHT 0x02
#define MOVELEFT 0x03
#define MOVEBACK 0x04

#define UP 0x01
#define DOWN 0x02
#define RIGHT 0x03
#define LEFT  0x04
#define NONE	0x00

#define CHARMODE	0x05
#define GRAPHICMODE	0x06

/*serial port*/
void CloseSerialPort(void);



#ifdef __cplusplus
    }
#endif

#endif //LIBW83627_H_
